//
//  AppearanceKeys.swift
//  TuskerPreferences
//
//  Created by Shadowfacts on 4/13/24.
//

import Foundation
import UIKit

struct ThemeKey: PreferenceKey {
    static var defaultValue: Theme { .unspecified }
}

struct AccentColorKey: PreferenceKey {
    static var defaultValue: AccentColor { .default }
}

struct AvatarStyleKey: PreferenceKey {
    static var defaultValue: AvatarStyle { .roundRect }
}

struct LeadingSwipeActionsKey: PreferenceKey {
    static var defaultValue: [StatusSwipeAction] { [.favorite, .reblog] }
}

struct TrailingSwipeActionsKey: PreferenceKey {
    static var defaultValue: [StatusSwipeAction] { [.reply, .share] }
}

struct WidescreenNavigationModeKey: PreferenceKey {
    static var defaultValue: WidescreenNavigationMode { .splitScreen }
}

struct AttachmentBlurModeKey: PreferenceKey {
    static var defaultValue: AttachmentBlurMode { .useStatusSetting }
    
    static func didSet(in store: PreferenceStore, newValue: AttachmentBlurMode) {
        if newValue == .always {
            store.blurMediaBehindContentWarning = true
        } else if newValue == .never {
            store.blurMediaBehindContentWarning = false
        }
    }
}
